#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#include <math.h>

// non e' il miglior modo per via dellla generazione dei numeri random

unsigned int * circle_count;
int numoft = -1;
int n = -1;

void * function (void * ptr) {
  int i = *((int *)ptr), j;
  
  circle_count[i] = 0;  
  for (j=0; j<n/numoft; j++) {
    double x, y; 

    x = (double) rand() / ((double)RAND_MAX + 1.0e0);
    y = (double) rand() / ((double)RAND_MAX + 1.0e0);

    if ((pow(x, 2.0) + pow(y, 2.0)) < 1.0)
      (circle_count[i])++;
  }

  pthread_exit(NULL);
}

int main (int argc, char ** argv) {
  float pi;
  int * rank;
  pthread_t *thread;
  int i, iret, tot_circle = 0;

  if (argc == 3) {
    numoft = atoi (argv[1]);
    n = atoi (argv[2]);
  }

  if (numoft < 0)
    numoft = 2;

  if (n < 0)
    n = 1000000;

  srand(10);

  circle_count = (unsigned int *) malloc (numoft * sizeof(unsigned int));
  // is NULL ?
  thread = (pthread_t *) malloc (numoft * sizeof(pthread_t));
  // is NULL ?
  rank = (int *) malloc (numoft * sizeof(int));
  // is NULL ?

  for (i=0; i<numoft; i++) {
    rank[i] = i;
    iret = pthread_create (&thread[i], NULL, function, (void *) &rank[i]);
  }

  tot_circle = 0;
  for (i=0; i<numoft; i++) {
    pthread_join (thread[i], NULL);
    tot_circle += circle_count[i];
  }

  free (circle_count);
  free (thread);
  free (rank);

  pi = (double) tot_circle / (double) n;
  pi *= 4.0e0;

  fprintf (stdout, "PI %.23f\n", pi);
     
  return EXIT_SUCCESS;
}
