#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#include <math.h>

// non e' il miglior modo per via dellla generazione dei numeri random

unsigned int circle_count;
pthread_mutex_t reduction_mutex;

//pthread_mutex_t rand_mutex;

int numoft = -1;
int n = -1;

void * function (void * ptr) {
  int j;
  unsigned int my_circle_count = 0;
  
  for (j=0; j<n/numoft; j++) {
    double x, y; 

    //pthread_mutex_lock(&rand_mutex);
    x = (double) rand() / ((double)RAND_MAX + 1.0e0);
    y = (double) rand() / ((double)RAND_MAX + 1.0e0);
    //pthread_mutex_unlock(&rand_mutex);

    if ((pow(x, 2.0) + pow(y, 2.0)) < 1.0)
      my_circle_count++;
  }

  pthread_mutex_lock(&reduction_mutex);
  circle_count += my_circle_count;
  pthread_mutex_unlock(&reduction_mutex);
 
  pthread_exit(NULL);
}

int main (int argc, char ** argv) {
  pthread_t *thread;
  int i, iret;
  float pi;

  if (argc == 3) {
    numoft = atoi (argv[1]);
    n = atoi (argv[2]);
  }

  if (numoft < 0)
    numoft = 2;

  if (n < 0)
    n = 1000000;

  srand(10);
  circle_count = 0;

  thread = (pthread_t *) malloc (numoft * sizeof(pthread_t));
  // is NULL ?

  if(pthread_mutex_init (&reduction_mutex, NULL)) {
    fprintf (stderr, "Cannot init lock\n");
    exit (EXIT_FAILURE); 
  }

  //if(pthread_mutex_init (&rand_mutex, NULL)) {
  //  fprintf (stderr, "Cannot init lock\n");
  //  exit (EXIT_FAILURE); 
  //}

  for (i=0; i<numoft; i++) 
    iret = pthread_create (&thread[i], NULL, function, NULL);

  for (i=0; i<numoft; i++) 
    pthread_join (thread[i], NULL);
  //pthread_mutex_destroy (&rand_mutex);
  pthread_mutex_destroy (&reduction_mutex);

  free (thread);

  pi = (double) circle_count / (double) n;
  pi *= 4.0e0;

  fprintf (stdout, "PI %.23f\n", pi);
     
  return EXIT_SUCCESS;
}
